ScoopParser Class Reference documentation

ScoopParser Class Referencefinal

the main class to read a Scoop v1 file More...

`#include <ScoopParser.hxx>`

Inheritance diagram for ScoopParser:

## Public Member Functions
| ScoopParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~ScoopParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | readPrintInfo ()
| try to read the print info zone
bool | readHeader ()
| try to the header zone
bool | readTextZone (ScoopParserInternal::TextZone &tZone)
| try to read the data associated to a text zone: its name, its content, the list of shape which displayed this text
bool | readTextZoneParagraph (ScoopParserInternal::Paragraph &para, int id)
| try to read a frame paragraph
bool | readFont (MWAWFont &font)
| try to read a font style
bool | readParagraph (MWAWParagraph &para, bool define=false)
| try to read a paragraph style
bool | readText (MWAWEntry &entry, std::string const &what)
| try to read a text zone
bool | readShapesList (std::vector< ScoopParserInternal::Shape > &shapes, int depth=0)
| try to read a list of shape
bool | readShape (ScoopParserInternal::Shape &shape, int id, int depth=0)
| try to read a shape
bool | readBitmap (MWAWEntry const &entry, MWAWEmbeddedObject &object, bool compressed=true)
| try to read a bitmap
bool | send (ScoopParserInternal::Shape const &shape, MWAWVec2i const &decal)
| try to send a shape
bool | sendText (long tZoneId, int subZone)
| try to send the text of a text zone
bool | sendText (ScoopParserInternal::Paragraph const &paragraph)
| try to send the text corresponding to a paragraph
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< ScoopParserInternal::State > | m_state
| the state

## Friends
class | ScoopParserInternal::SubDocument

## Detailed Description

the main class to read a Scoop v1 file

## Constructor & Destructor Documentation

## ◆ ScoopParser()

ScoopParser::ScoopParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~ScoopParser()

ScoopParser::~ScoopParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool ScoopParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse(), and ScoopParserInternal::SubDocument.

## ◆ createDocument()

void ScoopParser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse(), and ScoopParserInternal::SubDocument.

## ◆ createZones()

bool ScoopParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and ScoopParserInternal::SubDocument.

## ◆ parse()

void ScoopParser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWGraphicParser.

Referenced by ScoopParserInternal::SubDocument.

## ◆ readBitmap()

bool ScoopParser::readBitmap | ( | MWAWEntry const & | entry,
|  | MWAWEmbeddedObject & | object,
|  | bool | compressed = true )
| protected

try to read a bitmap

Referenced by readShape(), ScoopParserInternal::SubDocument, and send().

## ◆ readFont()

bool ScoopParser::readFont | ( | MWAWFont & | font | ) |
| protected

try to read a font style

Referenced by readTextZone(), readTextZoneParagraph(), and ScoopParserInternal::SubDocument.

## ◆ readHeader()

bool ScoopParser::readHeader | ( |  | ) |
| protected

try to the header zone

Referenced by createZones(), and ScoopParserInternal::SubDocument.

## ◆ readParagraph()

bool ScoopParser::readParagraph | ( | MWAWParagraph & | para,
|  | bool | define = false )
| protected

try to read a paragraph style

Referenced by readTextZone(), readTextZoneParagraph(), and ScoopParserInternal::SubDocument.

## ◆ readPrintInfo()

bool ScoopParser::readPrintInfo | ( |  | ) |
| protected

try to read the print info zone

Referenced by readHeader(), and ScoopParserInternal::SubDocument.

## ◆ readShape()

bool ScoopParser::readShape | ( | ScoopParserInternal::Shape & | shape,
|  | int | id,
|  | int | depth = 0 )
| protected

try to read a shape

Referenced by readShapesList(), and ScoopParserInternal::SubDocument.

## ◆ readShapesList()

bool ScoopParser::readShapesList | ( | std::vector< ScoopParserInternal::Shape > & | shapes,
|  | int | depth = 0 )
| protected

try to read a list of shape

Referenced by createZones(), readShape(), and ScoopParserInternal::SubDocument.

## ◆ readText()

bool ScoopParser::readText | ( | MWAWEntry & | entry,
|  | std::string const & | what )
| protected

try to read a text zone

Referenced by readParagraph(), readTextZone(), readTextZoneParagraph(), and ScoopParserInternal::SubDocument.

## ◆ readTextZone()

bool ScoopParser::readTextZone | ( | ScoopParserInternal::TextZone & | tZone | ) |
| protected

try to read the data associated to a text zone: its name, its content, the list of shape which displayed this text

Referenced by createZones(), and ScoopParserInternal::SubDocument.

## ◆ readTextZoneParagraph()

bool ScoopParser::readTextZoneParagraph | ( | ScoopParserInternal::Paragraph & | para,
|  | int | id )
| protected

try to read a frame paragraph

Referenced by readTextZone(), and ScoopParserInternal::SubDocument.

## ◆ send()

bool ScoopParser::send | ( | ScoopParserInternal::Shape const & | shape,
|  | MWAWVec2i const & | decal )
| protected

try to send a shape

Referenced by parse(), ScoopParserInternal::SubDocument, and send().

## ◆ sendText() [1/2]

bool ScoopParser::sendText | ( | long | tZoneId,
|  | int | subZone )
| protected

try to send the text of a text zone

Referenced by ScoopParserInternal::SubDocument, and sendText().

## ◆ sendText() [2/2]

bool ScoopParser::sendText | ( | ScoopParserInternal::Paragraph const & | paragraph | ) |
| protected

try to send the text corresponding to a paragraph

## Friends And Related Symbol Documentation

## ◆ ScoopParserInternal::SubDocument

friend class ScoopParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<ScoopParserInternal::State> ScoopParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), parse(), readHeader(), readParagraph(), readShape(), readTextZone(), ScoopParser(), and sendText().

The documentation for this class was generated from the following files:

- ScoopParser.hxx
- ScoopParser.cxx